// Program to test daemon scanning.

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>        // struct sockaddr_un 
#include <sys/file.h>
#include <time.h>
#include <stdarg.h>
#include <paths.h>
#include <errno.h>
extern int errno;

//#define DEBUG_MESSAGES
#ifdef DEBUG_MESSAGES
 #define dprintf(args) printf args
#else
 #define dprintf(args) 
#endif

int AvpTestObject(int flags,char *szObjName);

// Shared memory
#include "shmem.h"
#ifdef USESHMEM

MemForUse *ShMem;
int semid;
#endif
// Shared memory definition end

// ... Cfg pathnames 
#define AVP_NODE_DIR      "/var/run"
#define AVP_NODE_DIR_MODE 0777
#define AVP_NODE_PID      AVP_NODE_DIR "/AvpPid"
#define AVP_NODE_LOG      AVP_NODE_DIR "/AvpLog"
#define AVP_NODE_CTL      AVP_NODE_DIR "/AvpCtl\0\0\0"
char *NodePid=AVP_NODE_PID;
char *NodeCtl=AVP_NODE_CTL;

static int  AvpFile=-1;		// fd for log 
static int  connected;		 // have done connect 
static int  TestMask = 0xff;	 // mask of priorities to be logged 

// set the test mask level
int setTestMask(int pmask)
 {
  int omask;

  omask=TestMask;
  if(pmask!=0) TestMask = pmask;
  return (omask);
 }

struct sockaddr_un AvpTestAddr;	// AF_UNIX address of local logger 
// start test
int AvpTestStart()
 {
  if(AvpFile==-1)
   {
    bzero((char *)&AvpTestAddr,sizeof(AvpTestAddr));
    AvpTestAddr.sun_family=AF_UNIX;
    strcpy(AvpTestAddr.sun_path,NodeCtl);
    if((AvpFile=socket(AF_UNIX,SOCK_STREAM,0))<0)
      printf("create socket error: socket() not created\n");
    // fcntl(AvpFile,F_SETFD,1); 
   }

  if(AvpFile!=-1 && !connected &&
    connect(AvpFile,(struct sockaddr *)(&AvpTestAddr),sizeof(AvpTestAddr.sun_family)+strlen("/var/run/AvpCtl"))>=0)
   connected=1;
  if(connected==1)
   {
    dprintf(("AvpTestStart connected to AvpDaemon\n")); 
    return 0;
   }    
  printf("AvpTestStart cannot connected to AvpDaemon\n"); 
  return -1;
 }

// close the testing
void AvpTestClose()
 {
  (void)close(AvpFile);
  AvpFile=-1;
  connected=0;
  dprintf(("AvpTestClose. connected=%d\n",connected)); 
 }

int AvpTestByDaemon(int flags,char *buftoscan,ULONG *ulFlags,ULONG* buflen)
 {
  register int len;
  register char *p;
  int fd;

  len=strlen(buftoscan);

  // output the message to the local logger 
  dprintf(("write string (%s) to AvpDaemon\n",tbuf));
  if(write(AvpFile,buftoscan,len+1)>=0)
   {
    int Rez,uintbuf=0; 
    char *ResultBuf;
waitrez:
    dprintf(("Wait rezults: \n"));
    if((Rez=read(AvpFile,(char*)&uintbuf,2))==-1) return -2;
    int ExitCode=uintbuf&0xff-0x30;
    if((uintbuf&0x000f)=='?') //0x3f
     printf("Disinfect queries: \n");
    else 
     printf("Test result: %x\n",ExitCode);
    dprintf(("Test rezult: 0x%x, flags: 0x%x\n",uintbuf&0x00ff,uintbuf&0xff00));
    ResultBuf=NULL;
    if((uintbuf&0xff00)!=0)
     {
      if((uintbuf&0x200)!=0)
       {
        if((Rez=read(AvpFile,(char*)buflen,sizeof(ULONG)))==-1) return -2;
	*ulFlags|=1;
       }
      if((uintbuf&0x100)!=0)
       {
        if((Rez=read(AvpFile,(char*)&uintbuf,sizeof(ULONG)))==-1) return -2;
        ResultBuf=(char*)malloc(uintbuf+1);
        ResultBuf[0]=0;
        char *ResultStr=ResultBuf;
        dprintf(("Result string lenght: %d\n",uintbuf));
        //if((Rez=recv(AvpFile,ResultStr,uintbuf,0))==-1) return -2;
        while((uintbuf>0)&&((Rez=recv(AvpFile,ResultStr,uintbuf,0))!=0))
         if(Rez==-1)
          { dprintf(("Client cannot reaf from AvpDaemon!")); return -2; }
         else 
          {
            uintbuf-=Rez;
            ResultStr[Rez]=0;
  	    ResultStr+=Rez;
          }
       }
     }  
    switch (ExitCode&0x0f)
     {
      case 8:	
        printf("Corrupted objects were found
\n");
        break;
      case 7:	
        printf("File AvpLinux is corrupted

\n");
        break;
      case 6:	
        printf("All viruses deleted\n");
        break;
      case 5:	
        printf("All viruses disinfected\n");
        break;
      case 4:	
        printf("Known viruses were detected
\n");
        break;
      case 3:	
        printf("Suspicious objects were found
\n");
        break;
      case 1:	
        printf("Virus scan was not complete
\n");
        break;
      case 0:	
        printf("No viruses were found\n");
        break;
      case 0xf:
        printf("%s",ResultBuf);
        free(ResultBuf);
        char dlgres;
        dlgres=getchar();
        if(dlgres!='\n') while(!feof(stdin) && (fgetc(stdin)!='\n')) ;
        int rezs;
        if((rezs=send(AvpFile,(char*)&dlgres,1,0))==-1)
          printf("Client can not write disinfect dialog result to AvpDaemon");
        goto waitrez;
      default:	
        printf("Error!(test result %d)\n",Rez);
        break;
     }
    switch (ExitCode&0xf0)
     {
      case 8:	
        printf("Internal error: Integrity failed.\n");
        break;
      case 4:	
        printf("Internal error: Bases not found.\n");
        break;
     }
    printf("Found viruses: %s\n",ResultBuf);
    free(ResultBuf);

    return ExitCode;
   }
  return -1;

  // output the message to the console; don't worry about
  // blocking, if console blocks everything will.
  if((fd=open(_PATH_CONSOLE,O_WRONLY|O_NOCTTY,0))<0) return -1;
  (void)strcat(buftoscan,"\r\n");
  len+=2;
  p=index(buftoscan,'>')+1;
  (void)write(fd,p,len-(p-buftoscan));
  (void)close(fd);
  return -1;
 }

int AvpTest(int flags,const char *fmt, ...)
 {
  int rez=-1;

  if(AvpFile<0 || !connected)
   if(AvpTestStart()!=0) return -1;

  va_list ap;

  va_start(ap, fmt);

  register char *p;
  int saved_errno=0;
  char tbuf[2048], fmt_cpy[1024];
  time_t now;

#ifdef USESHMEM
  flags|=FL_USESHMEM;
 #ifndef USESEM
  flags|=FL_DOUNTUSESEM;
 #endif
#endif

  // build the message 
  (void)time(&now);
  (void)sprintf(tbuf,"<%d>%.15s:",flags,ctime(&now)+4);
  for(p=tbuf;*p;++p) ;

  // substitute error message for %m 
   {
    register char ch, *t1, *t2;

    for(t1=fmt_cpy;(ch=*fmt)!='\0' && t1<fmt_cpy+sizeof(fmt_cpy);++fmt)
     if(ch=='%'&& fmt[1]=='m')
      {
       ++fmt;
       for(t2=strerror(saved_errno);(*t1 = *t2++);++t1);
      }
     else
      *t1++ =ch;
    *t1='\0';
   }
  (void)vsprintf(p,fmt_cpy,ap);

#ifdef USESHMEM
  struct stat statbuf;
  if(lstat(p,&statbuf)==-1)
   {
    dprintf(("Cannot find object(%s)\n",p));
    return -3;
   }    
  if(!S_ISREG(statbuf.st_mode))
   {
    dprintf(("%s is not a file\n",p));
    return -3;
   }    
   
  int hFile=-1; 
  if((hFile=open(p,
O_RDONLY))==(-1))
   {
    dprintf(("Error in open(%s)\n",p));
    return -3;
   }
  char *filename=(char*)malloc(strlen(p)+1);
  strcpy(filename,p);
  fstat(hFile,&statbuf);
  //z=lseek(hFile,0,SEEK_END);
  lseek(hFile,0,SEEK_SET);

  key_t key=IPC_PRIVATE;
  int shmid=-1;

  char *keyname=NULL; //"AvpDaemonTst"
  if(access(NodeCtl,0)!=-1) keyname=NodeCtl;
  else
   {
    perror("could not find program");
    free(filename);
    close(hFile);
    return -4;
   }     

  char chPrj='D';
  if((key=ftok(keyname,chPrj))<0) 
   {
    printf("umpossible take a key\n");
    free(filename);
    close(hFile);
    return -4;
   }
  dprintf(("key: <%x> keyname:<%s>\n",key,keyname));

  // create sharedmem buf
  if((shmid=shmget(key,(sizeof(MemForUse)+statbuf.st_size+(MemAlignment-1)) & ~(MemAlignment-1),PERM|IPC_CREAT))==-1) 
   {
    perror("could not allocate sharedmem buf");
    free(filename);
    close(hFile);
    return -4;
   }
  // attach it
  if((ShMem=(MemForUse *)shmat(shmid,0,0))<0) 
   {
    perror ("could not attach sharedmem buf");
    free(filename);
    close(hFile);
    if(shmctl(shmid,IPC_RMID,NULL)<0) perror("could not delete sharedmem buf");
    return -4;
   }

  if(read(hFile,ShMem->buf,statbuf.st_size)==-1)
   {
    dprintf(("Error in read(from %s %ld)\n",p,statbuf.st_size));
    free(filename);
    close(hFile);
    if(shmdt(ShMem)==-1) perror ("could not detach sharedmem buf");
    if(shmctl(shmid,IPC_RMID,NULL)<0) perror ("could not delete sharedmem buf");
    return -3;
   }
  close(hFile);
   
  dprintf(("From %s has been red %ld\n",p,statbuf.st_size));

  ShMem->params.ShMKey=key;
  ShMem->params.ShMSize=statbuf.st_size;
  (void)sprintf(p,"<%x|%lx|>",key,statbuf.st_size);

  if(shmdt(ShMem)==-1)
   {
    perror ("could not detach sharedmem buf");
    return -4;
   }
#endif
  
  ULONG ulFlags,ulDiffer;
  rez=AvpTestByDaemon(flags,tbuf,&ulFlags,&ulDiffer);
  if((ulFlags&1)!=0)
   {
    if((shmid=shmget(key,ulDiffer+sizeof(MemForUse),0))<0)
     {
      dprintf(("could not call shmget(%ld)\n",ulDiffer+sizeof(MemForUse)));
      free(filename);
      return -4;
     }
    dprintf(("call shmget successfully (%ld bytes)",ulDiffer+sizeof(MemForUse))); 
    // attach it
    if((ShMem=(MemForUse *)shmat(shmid,0,0))<0) 
     {
      dprintf(("could not attach sharedmem buf"));
      free(filename);
      if(shmctl(shmid,IPC_RMID,NULL)) dprintf(("could not delete sharedmem buf"));
      return -5;
     }
    dprintf(("sharedmem attached successfully."));

    if((hFile=open(filename,
O_WRONLY))==(-1))
     {
      dprintf(("Error in open(%s)\n",filename));
      free(filename);
      if(shmdt(ShMem)==-1) perror ("could not detach sharedmem buf");
      if(shmctl(shmid,IPC_RMID,NULL)<0) perror ("could not delete sharedmem buf");
      return -3;
     }
    lseek(hFile,0,SEEK_SET);
    if(write(hFile,ShMem->buf,ulDiffer)==-1)
      dprintf(("Error in write to %s %ld bytes\n",filename,ulDiffer));
    ftruncate(hFile,ulDiffer);
    close(hFile);
    free(filename);

    printf("File changed successfully\n");
    if(shmdt(ShMem)==-1) dprintf(("could not detach sharedmem buf"));
    // delete objects  
    if(shmctl(shmid,IPC_RMID,0)<0) dprintf(("umpossible delete shmem buf"));
   }
  switch (rez)
   {
    case -1:
      printf("Error: cannot write to AvpDaemon!\n");
      break;
    case -2:
      printf("Error: cannot read from AvpDaemon!\n");
      break;
    case -4:
      printf("Error: error in shared memory block!\n");
      break;
   }
  va_end(ap);
  return rez;
 }

int main(int argc,char *argv[])
 {
  int rez=-1;

  if(AvpTestStart()==0)
   if(argc>1)
    {
     if( (*argv[1]=='-') && (*(argv[1]+1)=='\0') )
      {
       auto char *nl,bufr[512];
       auto int tested=0;
       while (!feof(stdin))
	if(fgets(bufr, sizeof(bufr), stdin) !=(char *) 0 )
	 {
	  if( (nl=strrchr(bufr,'\n'))!=(char *)0) *nl='\0';
  	  rez=AvpTestObject(0,bufr);
	  tested+=strlen(bufr);
	  if(tested>1024)
	   {
	    sleep(1);
	    tested=0;
	   }
	 }
      }
     else
      while(argc-- >1) rez=AvpTestObject(0,argv++[1]);
    }
   else
    printf("Not object to test.\n");

  AvpTestClose();

  return(rez);
 }

#include <dirent.h>
char Symlinks=1,Directories=1,SubDirectories=1,CrossFs=1;

#ifndef PATH_MAX
#define PATH_MAX 1024
#endif

static int substr(char *s,char *old,char *news)
 {
  char *tmp=NULL;
  int oldlen=strlen(old), newlen = 0;

  if (NULL==strstr(s, old)) return 0;

  if(news)newlen=strlen(news);

  if(newlen>oldlen)
   {
    if((tmp=(char*)malloc(strlen(s)))==NULL)
     {
      fprintf(stderr, "no memory\n");
      return 1; // exit (1);
     }
   }

  while(NULL != (s = strstr(s, old)))
   {
    char *p,*old_s=s;

    if(news)
     {
      if(newlen > oldlen)
      old_s = strcpy(tmp, s);
      p=news;
      while (*p) *s++ = *p++;
     }
    p=old_s + oldlen;
    while ((*s++ = *p++));
   }
  if(tmp) free(tmp);
  return 1;
 }

int TidyPath (char *path)
 {
  int tidied = 0;
  char *s, *p;

  strcat(path,"/");	// tmp trailing slash simplifies things 
  while (substr(path, "/./", "/")) tidied = 1;
  while (substr(path, "//", "/"))  tidied = 1;

  while (NULL != (p = strstr(path,"/../")))
   {
    for (s = p+3; p != path && *--p != '/';);
    if (*p != '/') break;
    if (p == path) ++p;
    while ((*p++ = *s++));
    tidied = 1;
   }
  if (!*path) strcpy(path,"/");
  p = path + strlen(path) - 1;
  if(p != path && *p == '/') *p-- = '\0'; // remove tmp trailing slash 
  while (p != path && *p == '/')
   {	/* remove any others */
    *p-- = '\0';
    tidied = 1;
   }
  while (!strncmp(path,"./",2))
   {
    for (p = path, s = path+2; (*p++ = *s++););
    tidied = 1;
   }
  return tidied;
 }

char* CheckSymlink(char *path,dev_t my_dev)
 {
  static char slpath[PATH_MAX],abspath[PATH_MAX]; //,news[PATH_MAX]
  char *p;//, *lp, *tail, *msg,*np;
  struct stat stbuf;
  int c;//, fix_abs = 0, fix_messy = 0, fix_long = 0;

  if((c=readlink(path,slpath,sizeof(slpath))) == -1)
   {
    perror(path);
    return NULL;
   }
  slpath[c]='\0';	// readlink does not null terminate it

  // construct the absolute address of the link
  abspath[0]='\0';
  if(slpath[0] != '/')
   {
    strcat(abspath,path);
    if(((c=strlen(abspath)) > 0) && (abspath[c-1] == '/'))
	abspath[c-1] = '\0';
    if((p=strrchr(abspath,'/')) != NULL) *p='\0';
    strcat(abspath,"/");
   }
  strcat(abspath,slpath);
  TidyPath(abspath);

  // check for various things 
  if(stat(abspath,&stbuf)==-1)
   {
    return NULL;
   }
    return abspath;
 }

int ScanFile(int flags,char *fullFileName,unsigned long fileSize)
 {
  int rez=0;
  //if(cmpFileMask(fullFileName)==TRUE) return 0;
  rez=AvpTest(flags,fullFileName);
  return rez;
 }

void ScanTree(int flags,char *CurrDir,dev_t dev)
 {
  struct stat fStats;
  char szFileName[PATH_MAX+1];

  strcpy(szFileName,CurrDir);
  if(strlen(szFileName)>1)
   if(szFileName[strlen(szFileName)-1]=='/') szFileName[strlen(szFileName)-1]=0;
  
  if(lstat(szFileName,&fStats)==-1) return;
  if(S_ISDIR(fStats.st_mode))
   {
    //if(cmpDirMask(szFileName)) return;

    DIR *dp;

    if((dp=opendir(szFileName))!=NULL)
     {
      int pathLen=strlen(szFileName);
      char *dirName=szFileName+pathLen;
      if(*(dirName-1)!='/')  *dirName++='/';
      struct dirent *dirp;
      dprintf(("open dir %s\n",szFileName));
      while((dirp=readdir(dp))!=NULL)
       {
        dprintf(("read dir %s\n",dirp->d_name));

        if(strcmp(dirp->d_name,".") && strcmp(dirp->d_name,".."))
         {
          strcpy(dirName,dirp->d_name);
          struct stat st;
          if(lstat(szFileName,&st)!=-1)
          //if(st.st_dev==dev)
           {
            dprintf(("read dir %s \n",szFileName));
	    if(S_ISLNK(st.st_mode))
	     {
              if(Symlinks==2)
	       {
	        char *TargetPath=CheckSymlink(szFileName,fStats.st_dev);
                dprintf(("read symlink %s %s\n",szFileName,TargetPath));
	        if(TargetPath!=NULL)
                 if(lstat(TargetPath,&st)!=-1)
  	          if(S_ISDIR(st.st_mode))
		   {
                    if(SubDirectories)    
  		     if((CrossFs==1)||((CrossFs==0)&&(st.st_dev==dev)))
		        ScanTree(flags,TargetPath,st.st_dev);
		   }
                  else
                   {
		    dprintf(("read file%s \n",szFileName));
                    if(S_ISREG(st.st_mode) )
	              ScanFile(flags,TargetPath,st.st_size);
 	           }
	       } 
	     }  
	    else
	      if(S_ISDIR(st.st_mode))
	       {
                if(SubDirectories)    
                 if((CrossFs==1)||((CrossFs==0)&&(st.st_dev==dev)))
		    ScanTree(flags,szFileName,dev);
	       }
              else
               {
                dprintf(("read file %s \n",szFileName));
                if(S_ISREG(st.st_mode) )
	         ScanFile(flags,szFileName,st.st_size);
	       } 
           }
         }
       }	 
      if(closedir(dp)<0) { dprintf(("Can't close directory: %s\n",szFileName)); }
      szFileName[pathLen]='\0';
     }
   }
  return;
 }

int AvpTestObject(int flags,char *szObjName)
 {
  struct stat st;
  if(lstat(szObjName,&st)==-1)
   {
    dprintf(("Cannot fihd object (%s). LStat()=-1\n",szObjName));
    return -2;
   }    
  dprintf(("Try to check type of test object %s \n",szObjName));
  if(S_ISLNK(st.st_mode))
   {
    if((Symlinks==1)||(Symlinks==2))
     {                                        
      char *TargetPath=CheckSymlink(szObjName,st.st_dev);//dev);
      dprintf(("Type: symlink %s -> %s\n",szObjName,TargetPath));
      if(TargetPath!=NULL)
       if(lstat(TargetPath,&st)!=-1)
        if(S_ISDIR(st.st_mode))
	 {
          dprintf(("Type: directory. Try to test directory %s from symlink %s \n",TargetPath,szObjName));
          if(Directories==1) ScanTree(flags,TargetPath,st.st_dev);
	  return 0;
	 }
        else
         {
          if(S_ISREG(st.st_mode) )
	   {
  	    dprintf(("Type: regular file. Try to test file %s from symlink %s \n",TargetPath,szObjName));
            return ScanFile(flags,szObjName,st.st_size);
	   }    
 	 }
     } 
   }  
  else
    if(S_ISDIR(st.st_mode))
     {
      dprintf(("Type: directory. Try to test %s \n",szObjName));
      if(Directories==1) ScanTree(flags,szObjName,st.st_dev); 
      return 5;
     }
    else
     {
      if(S_ISREG(st.st_mode) )
       {
        dprintf(("Type: regular file. Try to test %s \n",szObjName));
        return ScanFile(flags,szObjName,st.st_size);
       }	
     }
  return -1;
 }

